"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = alterDOMNodes;

var _map = _interopRequireDefault(require("ramda/src/map"));

var _identity = _interopRequireDefault(require("ramda/src/identity"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function alterDOMNodes(nodes, params) {
  const {
    alterDOMElement = _identity.default,
    alterDOMChildren = _identity.default,
    alterDOMData = node => node.data
  } = params;
  return (0, _map.default)(function applyParams(node) {
    let nextNode = node;

    if (node.type === 'tag') {
      const elementNode = alterDOMElement(node) || nextNode;
      const alteredChildren = alterDOMChildren(elementNode.children);
      elementNode.children = Array.isArray(alteredChildren) ? alteredChildren : elementNode.children;
      elementNode.children = alterDOMNodes(elementNode.children, params);
      nextNode = elementNode;
    } else if (node.type === 'text') {
      const textNode = node;
      const alteredData = alterDOMData(textNode);
      textNode.data = typeof alteredData === 'string' ? alteredData : textNode.data;
    }

    return nextNode;
  }, nodes);
}
//# sourceMappingURL=alterDOMNodes.js.map